package roberto_r_168295;

import javafx.application.Application;
import javafx.event.Event;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.*;
import javafx.stage.Stage;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.control.Label;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.Group;
import javafx.scene.text.*;
import javafx.animation.*;
import javafx.scene.control.TextField;
import javafx.util.Duration;

public class SlotMachine extends Application {
    
    
    Moneta moneta1 = new Moneta();
    Moneta moneta2 = new Moneta();
    Moneta moneta3 = new Moneta();
    Simbolo simbolo1 = new Simbolo();
    Simbolo simbolo2 = new Simbolo();
    Simbolo simbolo3 = new Simbolo();
    HBox box1 = new HBox();
    VBox vertbox = new VBox();
    TextField creditotx = new TextField("0"); 
    int credito = 0;
    int punt = 0;
    TextField punteggiotx = new TextField("0");
    Button nuovabtn = new Button("Nuova Partita");
    Button spinbtn = new Button("Spin");
    Button paybtn = new Button("Pay");
    
    
    
    
     BorderPane dolayout(){
    
        BorderPane border = new BorderPane();
        
        
        VBox boxv = new VBox();
        boxv.setAlignment(Pos.CENTER);
        boxv.setSpacing(80);
        boxv.setPadding(new Insets(0,0,0,100));
        
        box1 = new HBox();
        box1.setAlignment(Pos.CENTER);
        box1.getChildren().addAll(simbolo1,simbolo2,simbolo3);
        Simbollist simbl = new Simbollist();
        simbolo1.setOnMouseClicked(simbl);
        simbolo2.setOnMouseClicked(simbl);
        simbolo3.setOnMouseClicked(simbl);
        box1.setSpacing(10);
        
        HBox box2 = new HBox();
        box2.setAlignment(Pos.CENTER);
        box2.getChildren().addAll(creditotx,punteggiotx);
        box2.setSpacing(130);
        creditotx.setAlignment(Pos.CENTER_RIGHT); punteggiotx.setAlignment(Pos.CENTER_RIGHT);
        creditotx.setEditable(false); punteggiotx.setEditable(false);
        
        HBox box3 = new HBox();
        box3.setAlignment(Pos.CENTER);
        box3.setSpacing(250);
        box3.getChildren().addAll(new Label("Credito"),new Label("Punteggio"));
        
        VBox boxtmp = new VBox();
        boxtmp.getChildren().addAll(box2,box3);
        boxtmp.setSpacing(10);                   
        
        boxv.getChildren().addAll(box1,boxtmp);
        border.setCenter(boxv);
        
        
    
        
        Label lab = new Label("Super\n  Slot");     
        lab.setAlignment(Pos.CENTER);
        lab.setFont(Font.font("Arial", FontWeight.BOLD, 30));
        lab.setLayoutX(250);
        lab.setLayoutY(15);
        Rectangle R = new Rectangle(600,100);
        R.setFill(Color.RED);
        R.setStroke(Color.BLACK);
        R.setStrokeWidth(5);
        Group g = new Group();
        g.getChildren().addAll(R,lab);
        border.setTop(g);
        BorderPane.setAlignment(g, Pos.CENTER);
        
        
        HBox boxbot = new HBox();
        boxbot.getChildren().addAll(nuovabtn,spinbtn,paybtn);
        boxbot.setSpacing(40);
        boxbot.setAlignment(Pos.CENTER);
        boxbot.setPadding(new Insets(10,10,50,10));
        spinbtn.setDisable(true);
        paybtn.setDisable(true);
        nuovabtn.setMinSize(50, 50);
        spinbtn.setMinSize(50, 50);
        paybtn.setMinSize(50, 50);
        border.setBottom(boxbot);
        
        
        
        vertbox = new VBox();
        vertbox.setAlignment(Pos.CENTER);
        vertbox.setSpacing(30);        
        vertbox.setPadding(new Insets(10,50,10,10));
        vertbox.getChildren().addAll(moneta1,moneta2,moneta3);
        Listmonete listm = new Listmonete();
        moneta1.setOnMouseClicked(listm);
        moneta2.setOnMouseClicked(listm);
        moneta3.setOnMouseClicked(listm);
        border.setRight(vertbox);
        
        return border;

    }
    
    void aggcredito(){
    
    creditotx.setText(""+credito);
    
    if (credito == 0){ paybtn.setDisable(true); }
    else if (credito > 0){ paybtn.setDisable(false); }
    
    }
    
    void aggpunt(){
    
    punteggiotx.setText(""+punt);
    
     if (punt== 0){ spinbtn.setDisable(true); }
    else if (punt > 0){ spinbtn.setDisable(false); }
        
    }
    
    class Listmonete implements EventHandler{
    
    
    public void handle(Event t){
    
        
        
        Timeline tl = new Timeline();
        tl.getKeyFrames().addAll(
    new KeyFrame(Duration.seconds(1),new KeyValue( ((Moneta)t.getSource()).layoutYProperty(), -150)));
      
    
    tl.setOnFinished(new EventHandler(){public void handle(Event t){
    
        credito = credito+100;
        aggcredito();
    
    }});
        
      
        
      tl.play();
        
    }};
       
    void addlistnuova(){
    
    nuovabtn.setOnAction(new EventHandler(){public void handle(Event t){
    
    if (credito<100){
    
        Label tex = new Label("Non hai credito sufficente");
        tex.setAlignment(Pos.CENTER);
        tex.setFont(Font.font("Arial", FontWeight.BOLD, 20));
        Scene sc = new Scene(tex,500,200);
        Stage stg = new Stage();
        stg.setScene(sc);
        stg.centerOnScreen();
        stg.show();
    
    }
   
    
    else {
    
       credito= credito-100;
       punt = 128;
       aggcredito();
       aggpunt();
    }
    
    
    }});
        
    }
    
    void addlistspin(){
    
    spinbtn.setOnAction(new EventHandler(){
    
    public void handle(Event t){
    
     simbolo1 = new Simbolo();
     simbolo2 = new Simbolo();
     simbolo3 = new Simbolo();
     Simbollist simbl = new Simbollist();
     simbolo1.setOnMouseClicked(simbl);
     simbolo2.setOnMouseClicked(simbl);
     simbolo3.setOnMouseClicked(simbl);   
     box1.getChildren().clear();
     box1.getChildren().addAll(simbolo1,simbolo2,simbolo3);
     
     
     if (punt == 1){punt=0;}
     else {punt = punt/2;}   
     
     aggpunt();
     checksimbol();
     
        
    }
    
    });
    
    
    
    }       
    
    class Simbollist implements EventHandler {public void handle(Event t){
    
  if (punt!=0){
      
    int k = box1.getChildren().indexOf(t.getSource());
    box1.getChildren().remove(t.getSource()); 
    
  if (k==0) {simbolo1=new Simbolo();box1.getChildren().add(k,simbolo1);simbolo1.setOnMouseClicked(this);}
  else if (k==1){simbolo2 = new Simbolo();box1.getChildren().add(k,simbolo2);simbolo2.setOnMouseClicked(this);}
  else if (k==2){simbolo3 = new Simbolo();box1.getChildren().add(k,simbolo3);simbolo3.setOnMouseClicked(this);}
  
   punt = punt/2;
   aggpunt();
   checksimbol();
    
  
  }  
    
 
    }}
    
    void checksimbol(){
    
    String s1 = box1.getChildren().get(0).getId();
    String s2 = box1.getChildren().get(1).getId();
    String s3 = box1.getChildren().get(2).getId();
    
    if (s1 == s2 & s2 == s3 ){ 
        
        Label tex = new Label("Hai Vinto");
        tex.setAlignment(Pos.CENTER);
        tex.setFont(Font.font("Arial", FontWeight.BOLD, 20));
        Scene sc = new Scene(tex,500,200);
        Stage stg = new Stage();
        stg.setScene(sc);
        stg.centerOnScreen();
        stg.show();
        
        credito = credito + punt*100;
        punt = 0;
        aggcredito();
        aggpunt();
    } 
    
    
    }
    
    void addlistpay(){
    
        paybtn.setOnMouseClicked(new EventHandler(){
        
        public void handle (Event t){
        
        Label tex = new Label("Hai Vinto "+credito/100+ " Euro");
        tex.setAlignment(Pos.CENTER);
        tex.setFont(Font.font("Arial", FontWeight.BOLD, 20));
        Scene sc = new Scene(tex,500,200);
        Stage stg = new Stage();
        stg.setScene(sc);
        stg.centerOnScreen();
        stg.show();
        reset();
            
        
        }
        
        });
                            
   
    }
    
    void reset(){
    
        credito = 0;
        punt = 0;
        aggcredito();
        aggpunt();
        vertbox.getChildren().clear();
        moneta1 = new Moneta();
        moneta2 = new Moneta();
        moneta2 = new Moneta();
        Listmonete listm = new Listmonete();
        moneta1.setOnMouseClicked(listm);
        moneta2.setOnMouseClicked(listm);
        moneta3.setOnMouseClicked(listm);
        vertbox.getChildren().addAll(moneta1,moneta2,moneta3);
    
    }
    
    public void start(Stage primaryStage) {
        
        this.addlistnuova();
        this.addlistspin();
        this.addlistpay();
        Scene scene = new Scene(this.dolayout(), 1000, 800);  
        primaryStage.setTitle("SlotMachine");
        primaryStage.setScene(scene);
        primaryStage.centerOnScreen();
        primaryStage.show();
    }
    
    public static void main(String[] args) {
        launch(args);
    }
    
}
